"use strict";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var cssnano = require('cssnano');

var merge = require('webpack-merge');

var TerserPlugin = require("terser-webpack-plugin");

var MiniCssExtractPlugin = require("mini-css-extract-plugin");

var HtmlWebpackExternalsPlugin = require('html-webpack-externals-plugin');

var OptimizeCSSAssetsPlugin = require('optimize-css-assets-webpack-plugin');

var baseConfig = require('./webpack.base.config');

var prodConfig = _defineProperty({
  mode: "production",
  optimization: {
    minimizer: [new TerserPlugin({
      cache: true,
      parallel: true
    })]
  },
  devtool: false,
  module: {
    rules: [{
      test: /\.css$/,
      use: [MiniCssExtractPlugin.loader, {
        loader: "css-loader",
        options: {
          modules: true,
          localIdentName: "[name]__[local]--[hash:base64:5]"
        }
      }]
    }, {
      test: /\.scss$/,
      use: [MiniCssExtractPlugin.loader, {
        loader: "css-loader",
        options: {
          modules: true,
          localIdentName: "[name]__[local]--[hash:base64:5]"
        }
      }, "sass-loader"]
    }]
  },
  plugins: [new MiniCssExtractPlugin({
    filename: "static/css/[name].[contenthash].css"
  }) // new OptimizeCSSAssetsPlugin({
  //   assetNameRegExp: /\.css$/g,
  //   cssProcessor: cssnano,
  // }),
  // new HtmlWebpackExternalsPlugin({
  //   externals: [
  //     {
  //       module: 'react',
  //       entry: 'https://11.url.cn/now/lib/16.2.0/react.min.js',
  //       global: 'React',
  //     },
  //     {
  //       module: 'react-dom',
  //       entry: 'https://11.url.cn/now/lib/16.2.0/react-dom.min.js',
  //       global: 'ReactDOM',
  //     },
  //   ],
  // }),
  ]
}, "optimization", {
  splitChunks: {
    minSize: 0,
    cacheGroups: {
      commons: {
        name: "commons",
        chunks: "all",
        minChunks: 2
      }
    }
  }
});

module.exports = merge(baseConfig, prodConfig);